Index: trunk/SophyaLib/BaseTools/gnumd5.c
===================================================================
--- trunk/SophyaLib/BaseTools/gnumd5.c	(revision 742)
+++ trunk/SophyaLib/BaseTools/gnumd5.c	(revision 742)
@@ -0,0 +1,415 @@
+/* md5.c - MD5 Message-Digest Algorithm
+ *	Copyright (C) 1995, 1996, 1998, 1999 Free Software Foundation, Inc.
+ *
+ * according to the definition of MD5 in RFC 1321 from April 1992.
+ * NOTE: This is *not* the same file as the one from glibc.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software Foundation,
+ * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+/* Written by Ulrich Drepper <drepper@gnu.ai.mit.edu>, 1995.  */
+/* heavily modified for GnuPG by <werner.koch@guug.de> */
+/* Modified by Eric.Aubourg@cea.fr for SOPHYA */
+
+/* Test values:
+ * ""                  D4 1D 8C D9 8F 00 B2 04  E9 80 09 98 EC F8 42 7E
+ * "a"                 0C C1 75 B9 C0 F1 B6 A8  31 C3 99 E2 69 77 26 61
+ * "abc                90 01 50 98 3C D2 4F B0  D6 96 3F 7D 28 E1 7F 72
+ * "message digest"    F9 6B 69 7D 7C B7 93 8D  52 5A 2F 31 AA F1 61 D0
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <assert.h>
+
+#include "machdefs.h"
+#include "bithelp.h"
+#include "gnumd5.h"
+
+#define DIM(v) (sizeof(v)/sizeof((v)[0]))
+
+#if SWAP==0
+#define BIG_ENDIAN_HOST 1
+#endif
+
+
+//typedef struct {
+//    uint_4 A,B,C,D;	  /* chaining variables */
+//    uint_4  nblocks;
+//    uint_1 buf[64];
+//    int  count;
+//} MD5_CONTEXT;
+
+
+void
+md5_init( MD5_CONTEXT *ctx )
+{
+    ctx->A = 0x67452301;
+    ctx->B = 0xefcdab89;
+    ctx->C = 0x98badcfe;
+    ctx->D = 0x10325476;
+
+    ctx->nblocks = 0;
+    ctx->count = 0;
+}
+
+
+
+
+/* These are the four functions used in the four steps of the MD5 algorithm
+   and defined in the RFC 1321.  The first function is a little bit optimized
+   (as found in Colin Plumbs public domain implementation).  */
+/* #define FF(b, c, d) ((b & c) | (~b & d)) */
+#define FF(b, c, d) (d ^ (b & (c ^ d)))
+#define FG(b, c, d) FF (d, b, c)
+#define FH(b, c, d) (b ^ c ^ d)
+#define FI(b, c, d) (c ^ (b | ~d))
+
+
+/****************
+ * transform n*64 bytes
+ */
+static void
+/*transform( MD5_CONTEXT *ctx, const void *buffer, size_t len )*/
+transform( MD5_CONTEXT *ctx, uint_1 *data )
+{
+    uint_4 correct_words[16];
+    uint_4 A = ctx->A;
+    uint_4 B = ctx->B;
+    uint_4 C = ctx->C;
+    uint_4 D = ctx->D;
+    uint_4 *cwp = correct_words;
+
+#ifdef BIG_ENDIAN_HOST
+    { int i;
+      uint_1 *p2, *p1;
+      for(i=0, p1=data, p2=(uint_1*)correct_words; i < 16; i++, p2 += 4 ) {
+	p2[3] = *p1++;
+	p2[2] = *p1++;
+	p2[1] = *p1++;
+	p2[0] = *p1++;
+      }
+    }
+#else
+    memcpy( correct_words, data, 64 );
+#endif
+
+
+#define OP(a, b, c, d, s, T)					    \
+  do								    \
+    {								    \
+      a += FF (b, c, d) + (*cwp++) + T; 	    \
+      a = rol(a, s);						    \
+      a += b;							    \
+    }								    \
+  while (0)
+
+    /* Before we start, one word about the strange constants.
+       They are defined in RFC 1321 as
+
+       T[i] = (int) (4294967296.0 * fabs (sin (i))), i=1..64
+     */
+
+    /* Round 1.  */
+    OP (A, B, C, D,  7, 0xd76aa478);
+    OP (D, A, B, C, 12, 0xe8c7b756);
+    OP (C, D, A, B, 17, 0x242070db);
+    OP (B, C, D, A, 22, 0xc1bdceee);
+    OP (A, B, C, D,  7, 0xf57c0faf);
+    OP (D, A, B, C, 12, 0x4787c62a);
+    OP (C, D, A, B, 17, 0xa8304613);
+    OP (B, C, D, A, 22, 0xfd469501);
+    OP (A, B, C, D,  7, 0x698098d8);
+    OP (D, A, B, C, 12, 0x8b44f7af);
+    OP (C, D, A, B, 17, 0xffff5bb1);
+    OP (B, C, D, A, 22, 0x895cd7be);
+    OP (A, B, C, D,  7, 0x6b901122);
+    OP (D, A, B, C, 12, 0xfd987193);
+    OP (C, D, A, B, 17, 0xa679438e);
+    OP (B, C, D, A, 22, 0x49b40821);
+
+#undef OP
+#define OP(f, a, b, c, d, k, s, T)  \
+    do								      \
+      { 							      \
+	a += f (b, c, d) + correct_words[k] + T;		      \
+	a = rol(a, s);						      \
+	a += b; 						      \
+      } 							      \
+    while (0)
+
+    /* Round 2.  */
+    OP (FG, A, B, C, D,  1,  5, 0xf61e2562);
+    OP (FG, D, A, B, C,  6,  9, 0xc040b340);
+    OP (FG, C, D, A, B, 11, 14, 0x265e5a51);
+    OP (FG, B, C, D, A,  0, 20, 0xe9b6c7aa);
+    OP (FG, A, B, C, D,  5,  5, 0xd62f105d);
+    OP (FG, D, A, B, C, 10,  9, 0x02441453);
+    OP (FG, C, D, A, B, 15, 14, 0xd8a1e681);
+    OP (FG, B, C, D, A,  4, 20, 0xe7d3fbc8);
+    OP (FG, A, B, C, D,  9,  5, 0x21e1cde6);
+    OP (FG, D, A, B, C, 14,  9, 0xc33707d6);
+    OP (FG, C, D, A, B,  3, 14, 0xf4d50d87);
+    OP (FG, B, C, D, A,  8, 20, 0x455a14ed);
+    OP (FG, A, B, C, D, 13,  5, 0xa9e3e905);
+    OP (FG, D, A, B, C,  2,  9, 0xfcefa3f8);
+    OP (FG, C, D, A, B,  7, 14, 0x676f02d9);
+    OP (FG, B, C, D, A, 12, 20, 0x8d2a4c8a);
+
+    /* Round 3.  */
+    OP (FH, A, B, C, D,  5,  4, 0xfffa3942);
+    OP (FH, D, A, B, C,  8, 11, 0x8771f681);
+    OP (FH, C, D, A, B, 11, 16, 0x6d9d6122);
+    OP (FH, B, C, D, A, 14, 23, 0xfde5380c);
+    OP (FH, A, B, C, D,  1,  4, 0xa4beea44);
+    OP (FH, D, A, B, C,  4, 11, 0x4bdecfa9);
+    OP (FH, C, D, A, B,  7, 16, 0xf6bb4b60);
+    OP (FH, B, C, D, A, 10, 23, 0xbebfbc70);
+    OP (FH, A, B, C, D, 13,  4, 0x289b7ec6);
+    OP (FH, D, A, B, C,  0, 11, 0xeaa127fa);
+    OP (FH, C, D, A, B,  3, 16, 0xd4ef3085);
+    OP (FH, B, C, D, A,  6, 23, 0x04881d05);
+    OP (FH, A, B, C, D,  9,  4, 0xd9d4d039);
+    OP (FH, D, A, B, C, 12, 11, 0xe6db99e5);
+    OP (FH, C, D, A, B, 15, 16, 0x1fa27cf8);
+    OP (FH, B, C, D, A,  2, 23, 0xc4ac5665);
+
+    /* Round 4.  */
+    OP (FI, A, B, C, D,  0,  6, 0xf4292244);
+    OP (FI, D, A, B, C,  7, 10, 0x432aff97);
+    OP (FI, C, D, A, B, 14, 15, 0xab9423a7);
+    OP (FI, B, C, D, A,  5, 21, 0xfc93a039);
+    OP (FI, A, B, C, D, 12,  6, 0x655b59c3);
+    OP (FI, D, A, B, C,  3, 10, 0x8f0ccc92);
+    OP (FI, C, D, A, B, 10, 15, 0xffeff47d);
+    OP (FI, B, C, D, A,  1, 21, 0x85845dd1);
+    OP (FI, A, B, C, D,  8,  6, 0x6fa87e4f);
+    OP (FI, D, A, B, C, 15, 10, 0xfe2ce6e0);
+    OP (FI, C, D, A, B,  6, 15, 0xa3014314);
+    OP (FI, B, C, D, A, 13, 21, 0x4e0811a1);
+    OP (FI, A, B, C, D,  4,  6, 0xf7537e82);
+    OP (FI, D, A, B, C, 11, 10, 0xbd3af235);
+    OP (FI, C, D, A, B,  2, 15, 0x2ad7d2bb);
+    OP (FI, B, C, D, A,  9, 21, 0xeb86d391);
+
+    /* Put checksum in context given as argument.  */
+    ctx->A += A;
+    ctx->B += B;
+    ctx->C += C;
+    ctx->D += D;
+}
+
+
+
+/* The routine updates the message-digest context to
+ * account for the presence of each of the characters inBuf[0..inLen-1]
+ * in the message whose digest is being computed.
+ */
+void
+md5_write( MD5_CONTEXT *hd, uint_1 *inbuf, size_t inlen)
+{
+    if( hd->count == 64 ) { /* flush the buffer */
+	transform( hd, hd->buf );
+	hd->count = 0;
+	hd->nblocks++;
+    }
+    if( !inbuf )
+	return;
+    if( hd->count ) {
+	for( ; inlen && hd->count < 64; inlen-- )
+	    hd->buf[hd->count++] = *inbuf++;
+	md5_write( hd, NULL, 0 );
+	if( !inlen )
+	    return;
+    }
+
+    while( inlen >= 64 ) {
+	transform( hd, inbuf );
+	hd->count = 0;
+	hd->nblocks++;
+	inlen -= 64;
+	inbuf += 64;
+    }
+    for( ; inlen && hd->count < 64; inlen-- )
+	hd->buf[hd->count++] = *inbuf++;
+
+}
+
+
+
+/* The routine final terminates the message-digest computation and
+ * ends with the desired message digest in mdContext->digest[0...15].
+ * The handle is prepared for a new MD5 cycle.
+ * Returns 16 bytes representing the digest.
+ */
+
+void
+md5_final( MD5_CONTEXT *hd )
+{
+    uint_4 t, msb, lsb;
+    uint_1 *p;
+
+    md5_write(hd, NULL, 0); /* flush */;
+
+    msb = 0;
+    t = hd->nblocks;
+    if( (lsb = t << 6) < t ) /* multiply by 64 to make a byte count */
+	msb++;
+    msb += t >> 26;
+    t = lsb;
+    if( (lsb = t + hd->count) < t ) /* add the count */
+	msb++;
+    t = lsb;
+    if( (lsb = t << 3) < t ) /* multiply by 8 to make a bit count */
+	msb++;
+    msb += t >> 29;
+
+    if( hd->count < 56 ) { /* enough room */
+	hd->buf[hd->count++] = 0x80; /* pad */
+	while( hd->count < 56 )
+	    hd->buf[hd->count++] = 0;  /* pad */
+    }
+    else { /* need one extra block */
+	hd->buf[hd->count++] = 0x80; /* pad character */
+	while( hd->count < 64 )
+	    hd->buf[hd->count++] = 0;
+	md5_write(hd, NULL, 0);  /* flush */;
+	memset(hd->buf, 0, 56 ); /* fill next block with zeroes */
+    }
+    /* append the 64 bit count */
+    hd->buf[56] = lsb	   ;
+    hd->buf[57] = lsb >>  8;
+    hd->buf[58] = lsb >> 16;
+    hd->buf[59] = lsb >> 24;
+    hd->buf[60] = msb	   ;
+    hd->buf[61] = msb >>  8;
+    hd->buf[62] = msb >> 16;
+    hd->buf[63] = msb >> 24;
+    transform( hd, hd->buf );
+
+    p = hd->buf;
+#ifdef BIG_ENDIAN_HOST
+#define X(a) do { *p++ = hd->##a	  ; *p++ = hd->##a >> 8;      \
+		      *p++ = hd->##a >> 16; *p++ = hd->##a >> 24; } while(0)
+#else /* little endian */
+    /*#define X(a) do { *(uint_4*)p = hd->##a ; p += 4; } while(0)*/
+    /* Unixware's cpp doesn't like the above construct so we do it his way:
+     * (reported by Allan Clark) */
+#define X(a) do { *(uint_4*)p = (*hd).a ; p += 4; } while(0)
+#endif
+    X(A);
+    X(B);
+    X(C);
+    X(D);
+#undef X
+
+}
+
+static uint_1 *
+md5_read( MD5_CONTEXT *hd )
+{
+    return hd->buf;
+}
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+static const char *
+md5_get_info( int algo, size_t *contextsize,
+	       uint_1 **r_asnoid, int *r_asnlen, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, uint_1 *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       uint_1 *(**r_read)( void *c )
+	     )
+{
+    static uint_1 asn[18] = /* Object ID is 1.2.840.113549.2.5 */
+		    { 0x30, 0x20, 0x30, 0x0c, 0x06, 0x08, 0x2a, 0x86,0x48,
+		      0x86, 0xf7, 0x0d, 0x02, 0x05, 0x05, 0x00, 0x04, 0x10 };
+
+    if( algo != 1 )
+	return NULL;
+
+    *contextsize = sizeof(MD5_CONTEXT);
+    *r_asnoid = asn;
+    *r_asnlen = DIM(asn);
+    *r_mdlen = 16;
+    *r_init  = (void (*)(void *))md5_init;
+    *r_write = (void (*)(void *, uint_1*, size_t))md5_write;
+    *r_final = (void (*)(void *))md5_final;
+    *r_read  = (uint_1 *(*)(void *))md5_read;
+
+    return "MD5";
+}
+
+
+#ifndef IS_MODULE
+static
+#endif
+const char * const gnupgext_version = "MD5 ($Revision: 1.1 $)";
+
+static struct {
+    int class;
+    int version;
+    int  value;
+    void (*func)(void);
+} func_table[] = {
+    { 10, 1, 0, (void(*)(void))md5_get_info },
+    { 11, 1, 1 },
+};
+
+
+#ifndef IS_MODULE
+static
+#endif
+void *
+gnupgext_enum_func( int what, int *sequence, int *class, int *vers )
+{
+    void *ret;
+    int i = *sequence;
+
+    do {
+	if( i >= DIM(func_table) || i < 0 )
+	    return NULL;
+	*class = func_table[i].class;
+	*vers  = func_table[i].version;
+	switch( *class ) {
+	  case 11: case 21: case 31: ret = &func_table[i].value; break;
+	  default:		     ret = func_table[i].func; break;
+	}
+	i++;
+    } while( what && what != *class );
+
+    *sequence = i;
+    return ret;
+}
+
+
+
+/*
+#ifndef IS_MODULE
+void
+md5_constructor(void)
+{
+    register_internal_cipher_extension( gnupgext_version, gnupgext_enum_func );
+}
+#endif
+*/
+
+
+/* end of file */
Index: trunk/SophyaLib/BaseTools/gnumd5.h
===================================================================
--- trunk/SophyaLib/BaseTools/gnumd5.h	(revision 742)
+++ trunk/SophyaLib/BaseTools/gnumd5.h	(revision 742)
@@ -0,0 +1,34 @@
+#ifndef GNUMD5_H
+#define GNUMD5_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct {
+    uint_4 A,B,C,D;	  /* chaining variables */
+    uint_4  nblocks;
+    uint_1 buf[64];
+    int  count;
+} MD5_CONTEXT;
+
+
+void
+md5_init( MD5_CONTEXT *ctx );
+
+void
+md5_write( MD5_CONTEXT *hd, uint_1 *inbuf, size_t inlen);
+
+void
+md5_final( MD5_CONTEXT *hd );
+
+
+
+
+#ifdef __cplusplus
+}
+#endif
+
+
+
+#endif
Index: trunk/SophyaLib/BaseTools/md5.c
===================================================================
--- trunk/SophyaLib/BaseTools/md5.c	(revision 716)
+++ 	(revision )
@@ -1,289 +1,0 @@
-/*
- ***********************************************************************
- ** md5.c -- the source code for MD5 routines							**
- ** RSA Data Security, Inc. MD5 Message-Digest Algorithm				**
- ** Created: 2/17/90 RLR												**
- ** Revised: 1/91 SRD,AJ,BSK,JT Reference C ver., 7/10 constant corr.	**
- ***********************************************************************
- */
-
-/*
- ***********************************************************************
- ** Copyright (C) 1990, RSA Data Security, Inc. All rights reserved.	**
- ** 																	**
- ** License to copy and use this software is granted provided that		**
- ** it is identified as the "RSA Data Security, Inc. MD5 Message-		**
- ** Digest Algorithm" in all material mentioning or referencing this  	**
- ** software or this function.											**
- ** 																	**
- ** License is also granted to make and use derivative works			**
- ** provided that such works are identified as "derived from the RSA  	**
- ** Data Security, Inc. MD5 Message-Digest Algorithm" in all          	**
- ** material mentioning or referencing the derived work.				**
- ** 																	**
- ** RSA Data Security, Inc. makes no representations concerning 		**
- ** either the merchantability of this software or the suitability		**
- ** of this software for any particular purpose.	It is provided "as  **
- ** is" without express or implied warranty of any kind.             	**
- ** 																	**
- ** These notices must be retained in any copies of any part of this	**
- ** documentation and/or software.										**
- ***********************************************************************
- */
-
-#include "md5.h"
-
-/*
- ***********************************************************************
- **  Message-digest routines: 											**
- **  To form the message digest for a message M 						**
- ** 	 (1) Initialize a context buffer mdContext using MD5Init		**
- ** 	 (2) Call MD5Update on mdContext and M							**
- ** 	 (3) Call MD5Final on mdContext 								**
- **  The message digest is now in mdContext->digest[0...15] 			**
- ***********************************************************************
- */
-
-/* forward declaration */
-static void Transform (UINT4 *buf, UINT4 *in);
-
-static unsigned char PADDING[64] = {
-	0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
-};
-
-/* F, G, H and I are basic MD5 functions */
-#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
-#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
-#define H(x, y, z) ((x) ^ (y) ^ (z))
-#define I(x, y, z) ((y) ^ ((x) | (~z)))
-
-/* ROTATE_LEFT rotates x left n bits */
-#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))
-
-/* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4 */
-/* Rotation is separate from addition to prevent recomputation */
-#define FF(a, b, c, d, x, s, ac) \
-	{(a) += F ((b), (c), (d)) + (x) + (UINT4)(ac); \
-	 (a) = ROTATE_LEFT ((a), (s)); \
-	 (a) += (b); \
-	}
-#define GG(a, b, c, d, x, s, ac) \
-	{(a) += G ((b), (c), (d)) + (x) + (UINT4)(ac); \
-	 (a) = ROTATE_LEFT ((a), (s)); \
-	 (a) += (b); \
-	}
-#define HH(a, b, c, d, x, s, ac) \
-	{(a) += H ((b), (c), (d)) + (x) + (UINT4)(ac); \
-	 (a) = ROTATE_LEFT ((a), (s)); \
-	 (a) += (b); \
-	}
-#define II(a, b, c, d, x, s, ac) \
-	{(a) += I ((b), (c), (d)) + (x) + (UINT4)(ac); \
-	 (a) = ROTATE_LEFT ((a), (s)); \
-	 (a) += (b); \
-	}
-
-/* The routine MD5Init initializes the message-digest context
-	 mdContext. All fields are set to zero.
- */
-void MD5Init (MD5_CTX *mdContext)
-{
-	mdContext->i[0] = mdContext->i[1] = (UINT4)0;
-
-	/* Load magic initialization constants.
-	 */
-	mdContext->buf[0] = (UINT4)0x67452301;
-	mdContext->buf[1] = (UINT4)0xefcdab89;
-	mdContext->buf[2] = (UINT4)0x98badcfe;
-	mdContext->buf[3] = (UINT4)0x10325476;
-}
-
-/* The routine MD5Update updates the message-digest context to
-	 account for the presence of each of the characters inBuf[0..inLen-1]
-	 in the message whose digest is being computed.
- */
-void MD5Update (MD5_CTX *mdContext, unsigned char *inBuf, unsigned short inLen)
-{
-	UINT4 in[16];
-	short mdi;
-	unsigned short i, ii;
-
-	/* compute number of bytes mod 64 */
-	mdi = (short)((mdContext->i[0] >> 3) & 0x3F);
-
-	/* update number of bits */
-	if ((mdContext->i[0] + ((UINT4)inLen << 3)) < mdContext->i[0])
-		mdContext->i[1]++;
-	mdContext->i[0] += ((UINT4)inLen << 3);
-	mdContext->i[1] += ((UINT4)inLen >> 29);
-
-	while (inLen--) {
-		/* add new character to buffer, increment mdi */
-		mdContext->in[mdi++] = *inBuf++;
-
-		/* transform if necessary */
-		if (mdi == 0x40) {
-			for (i = 0, ii = 0; i < 16; i++, ii += 4)
-				in[i] = (((UINT4)mdContext->in[ii+3]) << 24) |
-								(((UINT4)mdContext->in[ii+2]) << 16) |
-								(((UINT4)mdContext->in[ii+1]) << 8) |
-								((UINT4)mdContext->in[ii]);
-			Transform (mdContext->buf, in);
-			mdi = 0;
-		}
-	}
-}
-
-/* The routine MD5Final terminates the message-digest computation and
-	 ends with the desired message digest in mdContext->digest[0...15].
- */
-void MD5Final (MD5_CTX *mdContext)
-{
-	UINT4 in[16];
-	short mdi;
-	unsigned short i, ii;
-	unsigned short padLen;
-
-	/* save number of bits */
-	in[14] = mdContext->i[0];
-	in[15] = mdContext->i[1];
-
-	/* compute number of bytes mod 64 */
-	mdi = (short)((mdContext->i[0] >> 3) & 0x3F);
-
-	/* pad out to 56 mod 64 */
-	padLen = (mdi < 56) ? (56 - mdi) : (120 - mdi);
-	MD5Update (mdContext, PADDING, padLen);
-
-	/* append length in bits and transform */
-	for (i = 0, ii = 0; i < 14; i++, ii += 4)
-		in[i] = (((UINT4)mdContext->in[ii+3]) << 24) |
-						(((UINT4)mdContext->in[ii+2]) << 16) |
-						(((UINT4)mdContext->in[ii+1]) << 8) |
-						((UINT4)mdContext->in[ii]);
-	Transform (mdContext->buf, in);
-
-	/* store buffer in digest */
-	for (i = 0, ii = 0; i < 4; i++, ii += 4) {
-		mdContext->digest[ii] = (unsigned char)(mdContext->buf[i] & 0xFF);
-		mdContext->digest[ii+1] =
-			(unsigned char)((mdContext->buf[i] >> 8) & 0xFF);
-		mdContext->digest[ii+2] =
-			(unsigned char)((mdContext->buf[i] >> 16) & 0xFF);
-		mdContext->digest[ii+3] =
-			(unsigned char)((mdContext->buf[i] >> 24) & 0xFF);
-	}
-}
-
-/* Basic MD5 step. Transforms buf based on in.
- */
-static void Transform (UINT4 *buf, UINT4 *in)
-{
-	UINT4 a = buf[0], b = buf[1], c = buf[2], d = buf[3];
-
-	/* Round 1 */
-#define S11 7
-#define S12 12
-#define S13 17
-#define S14 22
-	FF ( a, b, c, d, in[ 0], S11, 3614090360); /* 1 */
-	FF ( d, a, b, c, in[ 1], S12, 3905402710); /* 2 */
-	FF ( c, d, a, b, in[ 2], S13,  606105819); /* 3 */
-	FF ( b, c, d, a, in[ 3], S14, 3250441966); /* 4 */
-	FF ( a, b, c, d, in[ 4], S11, 4118548399); /* 5 */
-	FF ( d, a, b, c, in[ 5], S12, 1200080426); /* 6 */
-	FF ( c, d, a, b, in[ 6], S13, 2821735955); /* 7 */
-	FF ( b, c, d, a, in[ 7], S14, 4249261313); /* 8 */
-	FF ( a, b, c, d, in[ 8], S11, 1770035416); /* 9 */
-	FF ( d, a, b, c, in[ 9], S12, 2336552879); /* 10 */
-	FF ( c, d, a, b, in[10], S13, 4294925233); /* 11 */
-	FF ( b, c, d, a, in[11], S14, 2304563134); /* 12 */
-	FF ( a, b, c, d, in[12], S11, 1804603682); /* 13 */
-	FF ( d, a, b, c, in[13], S12, 4254626195); /* 14 */
-	FF ( c, d, a, b, in[14], S13, 2792965006); /* 15 */
-	FF ( b, c, d, a, in[15], S14, 1236535329); /* 16 */
-
-	/* Round 2 */
-#define S21 5
-#define S22 9
-#define S23 14
-#define S24 20
-	GG ( a, b, c, d, in[ 1], S21, 4129170786); /* 17 */
-	GG ( d, a, b, c, in[ 6], S22, 3225465664); /* 18 */
-	GG ( c, d, a, b, in[11], S23,  643717713); /* 19 */
-	GG ( b, c, d, a, in[ 0], S24, 3921069994); /* 20 */
-	GG ( a, b, c, d, in[ 5], S21, 3593408605); /* 21 */
-	GG ( d, a, b, c, in[10], S22, 	38016083); /* 22 */
-	GG ( c, d, a, b, in[15], S23, 3634488961); /* 23 */
-	GG ( b, c, d, a, in[ 4], S24, 3889429448); /* 24 */
-	GG ( a, b, c, d, in[ 9], S21,  568446438); /* 25 */
-	GG ( d, a, b, c, in[14], S22, 3275163606); /* 26 */
-	GG ( c, d, a, b, in[ 3], S23, 4107603335); /* 27 */
-	GG ( b, c, d, a, in[ 8], S24, 1163531501); /* 28 */
-	GG ( a, b, c, d, in[13], S21, 2850285829); /* 29 */
-	GG ( d, a, b, c, in[ 2], S22, 4243563512); /* 30 */
-	GG ( c, d, a, b, in[ 7], S23, 1735328473); /* 31 */
-	GG ( b, c, d, a, in[12], S24, 2368359562); /* 32 */
-
-	/* Round 3 */
-#define S31 4
-#define S32 11
-#define S33 16
-#define S34 23
-	HH ( a, b, c, d, in[ 5], S31, 4294588738); /* 33 */
-	HH ( d, a, b, c, in[ 8], S32, 2272392833); /* 34 */
-	HH ( c, d, a, b, in[11], S33, 1839030562); /* 35 */
-	HH ( b, c, d, a, in[14], S34, 4259657740); /* 36 */
-	HH ( a, b, c, d, in[ 1], S31, 2763975236); /* 37 */
-	HH ( d, a, b, c, in[ 4], S32, 1272893353); /* 38 */
-	HH ( c, d, a, b, in[ 7], S33, 4139469664); /* 39 */
-	HH ( b, c, d, a, in[10], S34, 3200236656); /* 40 */
-	HH ( a, b, c, d, in[13], S31,  681279174); /* 41 */
-	HH ( d, a, b, c, in[ 0], S32, 3936430074); /* 42 */
-	HH ( c, d, a, b, in[ 3], S33, 3572445317); /* 43 */
-	HH ( b, c, d, a, in[ 6], S34, 	76029189); /* 44 */
-	HH ( a, b, c, d, in[ 9], S31, 3654602809); /* 45 */
-	HH ( d, a, b, c, in[12], S32, 3873151461); /* 46 */
-	HH ( c, d, a, b, in[15], S33,  530742520); /* 47 */
-	HH ( b, c, d, a, in[ 2], S34, 3299628645); /* 48 */
-
-	/* Round 4 */
-#define S41 6
-#define S42 10
-#define S43 15
-#define S44 21
-	II ( a, b, c, d, in[ 0], S41, 4096336452); /* 49 */
-	II ( d, a, b, c, in[ 7], S42, 1126891415); /* 50 */
-	II ( c, d, a, b, in[14], S43, 2878612391); /* 51 */
-	II ( b, c, d, a, in[ 5], S44, 4237533241); /* 52 */
-	II ( a, b, c, d, in[12], S41, 1700485571); /* 53 */
-	II ( d, a, b, c, in[ 3], S42, 2399980690); /* 54 */
-	II ( c, d, a, b, in[10], S43, 4293915773); /* 55 */
-	II ( b, c, d, a, in[ 1], S44, 2240044497); /* 56 */
-	II ( a, b, c, d, in[ 8], S41, 1873313359); /* 57 */
-	II ( d, a, b, c, in[15], S42, 4264355552); /* 58 */
-	II ( c, d, a, b, in[ 6], S43, 2734768916); /* 59 */
-	II ( b, c, d, a, in[13], S44, 1309151649); /* 60 */
-	II ( a, b, c, d, in[ 4], S41, 4149444226); /* 61 */
-	II ( d, a, b, c, in[11], S42, 3174756917); /* 62 */
-	II ( c, d, a, b, in[ 2], S43,  718787259); /* 63 */
-	II ( b, c, d, a, in[ 9], S44, 3951481745); /* 64 */
-
-	buf[0] += a;
-	buf[1] += b;
-	buf[2] += c;
-	buf[3] += d;
-}
-
-/*
- ***********************************************************************
- ** End of md5.c														**
- ******************************** (cut) ********************************
- */
Index: trunk/SophyaLib/BaseTools/md5.h
===================================================================
--- trunk/SophyaLib/BaseTools/md5.h	(revision 716)
+++ 	(revision )
@@ -1,66 +1,0 @@
-/*
- ***********************************************************************
- ** md5.h -- header file for implementation of MD5						**
- ** RSA Data Security, Inc. MD5 Message-Digest Algorithm				**
- ** Created: 2/17/90 RLR												**
- ** Revised: 12/27/90 SRD,AJ,BSK,JT Reference C version 				**
- ** Revised (for MD5): RLR 4/27/91										**
- ** 	-- G modified to have y&~z instead of y&z 						**
- ** 	-- FF, GG, HH modified to add in last register done 			**
- ** 	-- Access pattern: round 2 works mod 5, round 3 works mod 3 	**
- ** 	-- distinct additive constant for each step 					**
- ** 	-- round 4 added, working mod 7 								**
- ***********************************************************************
- */
-
-/*
- ***********************************************************************
- ** Copyright (C) 1990, RSA Data Security, Inc. All rights reserved.	**
- ** 																	**
- ** License to copy and use this software is granted provided that		**
- ** it is identified as the "RSA Data Security, Inc. MD5 Message-    	**
- ** Digest Algorithm" in all material mentioning or referencing this  	**
- ** software or this function.											**
- ** 																	**
- ** License is also granted to make and use derivative works			**
- ** provided that such works are identified as "derived from the RSA  	**
- ** Data Security, Inc. MD5 Message-Digest Algorithm" in all			**
- ** material mentioning or referencing the derived work.				**
- ** 																	**
- ** RSA Data Security, Inc. makes no representations concerning 		**
- ** either the merchantability of this software or the suitability		**
- ** of this software for any particular purpose.	It is provided "as	**
- ** is" without express or implied warranty of any kind.              	**
- ** 																	**
- ** These notices must be retained in any copies of any part of this	**
- ** documentation and/or software.										**
- ***********************************************************************
- */
-#ifdef __cplusplus
-    extern "C" {
-#endif
-
-/* typedef a 32-bit type */
-typedef unsigned long  UINT4;
-
-/* Data structure for MD5 (Message-Digest) computation */
-typedef struct {
-	UINT4 i[2]; 							/* number of _bits_ handled mod 2^64 */
-	UINT4 buf[4]; 							/* scratch buffer */
-	unsigned char in[64]; 					/* input buffer */
-	unsigned char digest[16]; 				/* actual digest after MD5Final call */
-} MD5_CTX;
-
-void MD5Init (MD5_CTX *mdContext);
-void MD5Final (MD5_CTX *mdContext);
-void MD5Update (MD5_CTX *mdContext, unsigned char *inBuf, unsigned short inLen);
-
-#ifdef __cplusplus
-    }
-#endif
-
-/*
- ***********************************************************************
- ** End of md5.h														**
- ******************************** (cut) ********************************
- */
Index: trunk/SophyaLib/BaseTools/peidainit.cc
===================================================================
--- trunk/SophyaLib/BaseTools/peidainit.cc	(revision 716)
+++ trunk/SophyaLib/BaseTools/peidainit.cc	(revision 742)
@@ -70,5 +70,5 @@
 {
 if (fgprt) {
-  char* compiler;
+  char* compiler = 0;
   #ifdef __GNUG__
   compiler = "gcc " __VERSION__;
@@ -86,4 +86,7 @@
   compiler = const_cast<char *>("SGI-CC ") ;
   #endif
+  #ifdef __MWERKS__
+  compiler = const_cast<char *>("Codewarrior ");
+  #endif
   fprintf(stderr,"SOPHYA Version %4.1f Revision %d (%s) -- %s %s %s\n",
           SOPHYA_VERSION, SOPHYA_REVISION, SOPHYA_TAG,
Index: trunk/SophyaLib/BaseTools/ppersist.cc
===================================================================
--- trunk/SophyaLib/BaseTools/ppersist.cc	(revision 716)
+++ trunk/SophyaLib/BaseTools/ppersist.cc	(revision 742)
@@ -35,5 +35,5 @@
 
 
-MD5_CTX PIOPersist::ctx;
+MD5_CONTEXT PIOPersist::ctx;
 PIOPersist::ClassList * PIOPersist::classList = NULL;   // $CHECK$ Reza 26/04/99
 map<string, uint_8> * PIOPersist::typeids = NULL;
@@ -250,5 +250,12 @@
   rbuf[32] = '\0'; 
   struct tm tm;
-  strptime(rbuf,"%d/%m/%Y %T GMT",&tm);
+  #ifndef __MWERKS__
+  strptime(rbuf,"%d/%m/%Y %H:%M:%S GMT",&tm);
+  #else
+  sscanf(rbuf,"%2d/%2d/%4d %2d:%2d:%2d GMT",&tm.tm_mday,&tm.tm_mon,&tm.tm_year,
+                                            &tm.tm_hour,&tm.tm_min,&tm.tm_sec);
+  tm.tm_mon  --;
+  tm.tm_year -= 1900;
+  #endif
   creationdate = mktime(&tm);
 
@@ -809,5 +816,5 @@
   time_t tm = time(NULL);
   char datestring[33];
-  int l=strftime(datestring,32,"%d/%m/%Y %T GMT",gmtime(&tm));
+  int l=strftime(datestring,32,"%d/%m/%Y %H:%M:%S GMT",gmtime(&tm));
   for(int i=l; i<32; i++)  datestring[i] = ' ';
   datestring[32] = '\0'; 
Index: trunk/SophyaLib/BaseTools/ppersist.h
===================================================================
--- trunk/SophyaLib/BaseTools/ppersist.h	(revision 716)
+++ trunk/SophyaLib/BaseTools/ppersist.h	(revision 742)
@@ -11,5 +11,6 @@
 #include "machdefs.h"
 #include "pexceptions.h"
-#include "md5.h"
+#include "gnumd5.h"
+
 
 #include <time.h>
@@ -72,10 +73,10 @@
     static ClassCreatorFunc      FindCreatorFunc(uint_8 classId);
     static uint_8 Hash(string const& typname) {
-	MD5Init(&ctx);
-	MD5Update(&ctx, (unsigned char*) typname.c_str(), typname.size());
-	MD5Final(&ctx);
-	return ( *((uint_8*) ctx.digest) + *((uint_8*) (ctx.digest+8)));
+	md5_init(&ctx);
+	md5_write(&ctx, (unsigned char*) typname.c_str(), typname.size());
+	md5_final(&ctx);
+	return ( *((uint_8*) ctx.buf) + *((uint_8*) (ctx.buf+8)));
     }
-    static MD5_CTX ctx;
+    static MD5_CONTEXT ctx;
   
     static void Initialize();   // Pour initialiser classList
